@echo off
:: --- check whether the script runs with admin rights ---
net session >nul 2>&1
if errorlevel 1 (
	echo Please run this script as an administrator!
	pause
	exit /b
)

:: --- beginning of the script ---
setlocal
setlocal enableextensions
setlocal enabledelayedexpansion

set auth_test_page=https://test-eid.eesti.ee
set sign_test_page=https://hwcrypto.github.io/hwcrypto.js/sign
set logs[gemalto]=%TEMP%\esteidcm.log
set logs[gemalto.ie]=%TEMP%\Low\esteidcm.log
set logs[idemia]=%TEMP%\idemia\*.log
set output_dir="%USERPROFILE%\Desktop\minidriver_logs"
set regkey="HKLM\SOFTWARE\Microsoft\Cryptography\Calais\SmartCards\Estonian eID Device"
:: --- if Windows is 64-bit, two registry keys will be modified ---
reg query "HKLM\Hardware\Description\System\CentralProcessor\0" | find /i "x86" || set regkey64="HKLM\SOFTWARE\WOW6432Node\Microsoft\Cryptography\Calais\SmartCards\Estonian eID Device"

:: --- switch logging on ---
echo.
echo Step 1: start logging
echo.

echo. >>%logs[gemalto]%
echo. >>%logs[gemalto.ie]%

mkdir %TEMP%\idemia
reg add %regkey% /v DEBUG /t REG_DWORD /d 1 /f
reg add %regkey% /v FileName /d "%TEMP%\idemia\idemia_" /f
if defined regkey64 (
	reg add %regkey64% /v DEBUG /t REG_DWORD /d 1 /f
	reg add %regkey64% /v FileName /d "%TEMP%\idemia\idemia_" /f
)

:: --- perform test activities ---
echo.
echo Step 2: generating logs while using the ID-card
echo.
echo After pressing a key, your default web browser will open authentication and signing test pages
echo You may use these web sites or perform any other operations with the ID-card to generate the logs
echo.
echo After completing the testing please re-open the current window and press any key again
pause

start %auth_test_page%
start %sign_test_page%

:: --- switch logging off ---
echo.
echo When you have finished the testing activities, please press any key...
pause >nul
echo.
echo Step 3: stop logging and copy the log files to the desktop

reg delete %regkey% /v DEBUG /f
reg delete %regkey% /v FileName /f
if defined regkey64 (
	reg delete %regkey64% /v DEBUG /f
	reg delete %regkey64% /v FileName /f
)

:: --- move log files to desktop ---
mkdir "%output_dir%"
copy "%logs[gemalto]%" "%output_dir%"
copy "%logs[gemalto.ie]%" "%output_dir%\esteidcm_ie.log"
copy "%logs[idemia]%" "%output_dir%"
for %%i in (gemalto, gemalto.ie, idemia) do del "!logs[%%i]!"
rmdir "%TEMP%\idemia"

explorer "%output_dir%"

:: --- keep window open for some seconds ---
echo.
choice /t 6 /d n /n /m "the window will close soon..."
